package knihovna;

public class Knihovna {
    protected int pocetVsechVytisku;
    protected int pocetPujcenychVytisku;

    public Vytisk vytvorNovyVytisk(KnizniTitul kniha) {
	return new Vytisk(kniha, pocetVsechVytisku++);
    }

    public void pujcKnihu(Vytisk vytisk) {
	pocetPujcenychVytisku++;
	vytisk.vypujceno();
    }

    public void vratKnihu(Vytisk vytisk) {
	pocetPujcenychVytisku--;
	vytisk.vraceno();
    }

    public void vypisInfo() {
	System.out.println("Pocet vytisku="+pocetVsechVytisku);
	System.out.println("Pujcenych vytisku="+pocetPujcenychVytisku);
	System.out.println();
    }

    public static void main(String[] args) {
	Knihovna knihovna = new Knihovna();
	
	KnizniTitul babicka = new KnizniTitul("Bozena Nemcova", "Babicka");
	KnizniTitul kytice = new KnizniTitul("Karel Jaromir Erben", "Kytice");
	KnizniTitul temno = new KnizniTitul("Alois Jirasek", "Temno");

	Vytisk v1 = knihovna.vytvorNovyVytisk(babicka);
	Vytisk v2 = knihovna.vytvorNovyVytisk(babicka);
	Vytisk v3 = knihovna.vytvorNovyVytisk(kytice);
	Vytisk v4 = knihovna.vytvorNovyVytisk(temno);

	knihovna.pujcKnihu(v1);
	knihovna.pujcKnihu(v2);
	knihovna.pujcKnihu(v3);
	knihovna.vratKnihu(v1);
	
	v1.vypisInfo();
	v2.vypisInfo();
	v3.vypisInfo();
	v4.vypisInfo();

	knihovna.vypisInfo();
    }
}
