import junit.framework.*;
import java.util.ArrayList;

public class StackTest extends TestCase
{
	int[] intfield;
	char[] charfield; 
	Stack<Integer> intstack;
	Stack<Character> charstack;
	
	public void setUp()
	{
		intfield=new int[2];
		charfield=new char[2];
		intfield[0]=1;
		intfield[1]=2;
		intstack=new Stack<Integer>();
		charfield[0]='a';
		charfield[1]='b';
		charstack=new Stack<Character>();
	}

	
	public void testCount()
	{
		assertTrue("Prazdny intstack neni prazdny",(intstack.isEmpty())&&(intstack.count()==0));
		intstack.push(new Integer(1));
		assertEquals("Spatny pocet prvku v intstacku",intstack.count(),1);
		while(!intstack.isEmpty())intstack.pop();
		assertTrue("Prazdny charstack neni prazdny",(charstack.isEmpty())&&(charstack.count()==0));
		charstack.push(new Character('a'));
		assertEquals("Spatny pocet prvku v charstacku",charstack.count(),1);
		while(!charstack.isEmpty())charstack.pop();
	}


	public void testIsEmpty()
	{
		assertTrue(charstack.isEmpty());
		assertTrue(intstack.isEmpty());
	}

	public void testPush()
	{
		for(int i=0;i<intfield.length;i++)intstack.push(intfield[i]);
		assertEquals("Chyba: intstack.push - nesouhlasi pocet prvku",intstack.count(),2);
		for(int i=0;i<charfield.length;i++)charstack.push(charfield[i]);
		assertEquals("Chyba: charstack.push - nesouhlasi pocet prvku ",charstack.count(),2);
	}

	public void testPop()
	{
		int pom;
		for(int i=0;!intstack.isEmpty()&&i<intfield.length;i++)
		{
			pom=intstack.pop();
			assertEquals("Nejedna se o stack",pom,intfield[intfield.length-i-1]);
			
		}
		assertTrue("Intstack neni prazdny",intstack.isEmpty());	

		Character apom;
		for(int i=0;!charstack.isEmpty()&&i<charfield.length;i++)
		{
			apom=charstack.pop();
			assertEquals("Nejedna se o stack",apom,charfield[charfield.length-i-1]); 
		}
		assertTrue("Charstack neni prazdny",charstack.isEmpty());
	}
}
